/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbtkAny.cxx,v $
  Language:  C++
  Date:      $Date: 2008/10/17 08:18:12 $
  Version:   $Revision: 1.2 $
=========================================================================*/

/* ---------------------------------------------------------------------
* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */

#include "bbtkAny.h"


namespace bbtk
{
  /// The TypeTraits which validates all integer types
  template <> const bool integer<char>::value = true; 
  template <> const bool integer<short>::value = true;
  template <> const bool integer<int>::value = true; 
  template <> const bool integer<long>::value = true; 
  template <> const bool integer<long long>::value = true; 
  template <> const bool integer<unsigned char>::value = true; 
  template <> const bool integer<unsigned short>::value = true;
  template <> const bool integer<unsigned int>::value = true; 
  template <> const bool integer<unsigned long>::value = true; 
  template <> const bool integer<unsigned long long>::value = true; 

  /// The TypeTraits which validates all floating point number types
  template <> const bool floating_point<float>::value = true;
  template <> const bool floating_point<double>::value = true;
}

  
