#ifndef __vtkKWBlackBoxDialog_h_INCLUDED__
#define __vtkKWBlackBoxDialog_h_INCLUDED__

#ifdef USE_KWWIDGETS

#include "bbtkKWBlackBox.h"
#include "vtkKWDialog.h"
#include "vtkKWFrame.h"


typedef bbtk::KWBlackBox::Pointer BBPointer;
typedef bbtk::KWBlackBox::WeakPointer BBWeakPointer;

class BBTK_EXPORT vtkKWBlackBoxDialog : public vtkKWDialog,
					public WidgetBlackBoxWindow<vtkKWWidget>

{
public:
  

  static vtkKWBlackBoxDialog* New();

  vtkTypeRevisionMacro(vtkKWBlackBoxDialog,vtkKWDialog);
  void bbShow();  
  void bbHide();
  void bbClose();
  void Cancel();
  bool bbIsShown() { return mShown; }
  void bbSetBlackBox(BBPointer box) 
  { 
    mBox = box; 
    mBox.lock()->bbSetWindow(this);
  }
  virtual BBPointer bbGetBlackBox() { return mBox.lock(); }
  vtkKWFrame* GetFrame() { return mFrame; }
  void CreateWidget();
  //  void Pack();
protected:
  vtkKWBlackBoxDialog();
  ~vtkKWBlackBoxDialog();
private:
  vtkKWBlackBoxDialog(const vtkKWBlackBoxDialog&);   // Not implemented.
  void operator=(const vtkKWBlackBoxDialog&);  // Not implemented.
  BBWeakPointer mBox;
  bool mShown;
  vtkKWFrame* mFrame;
};
//==================================================================

#endif
#endif
