/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbstdCast.cxx,v $
  Language:  C++
  Date:      $Date: 2008/10/17 08:18:26 $
  Version:   $Revision: 1.4 $
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         


#include "bbstdCast.h"
#include "bbstdPackage.h"

namespace bbstd 
{
  
  //====================================================================
  BBTK_BLACK_BOX_TEMPLATE2_IMPLEMENTATION(Cast,
					  bbtk::AtomicBlackBox);
  //====================================================================
  
  //====================================================================
  // Add the instanciated adaptors to the package
  
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,double,int8_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int8_t,double);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,double,uint8_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint8_t,double);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,double,int16_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int16_t,double);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,double,uint16_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint16_t,double);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,double,int32_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int32_t,double);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,double,uint32_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint32_t,double);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,double,float);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,float,double);
  
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,bool,double);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,double, bool); 
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,bool,float);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,float, bool);    
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,bool,uint32_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint32_t, bool);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,bool,int32_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int32_t, bool);  
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,bool,uint16_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint16_t, bool);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,bool,int16_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int16_t, bool);  
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,bool,uint8_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint8_t, bool);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,bool,int8_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int8_t, bool);   
       
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,float,int8_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int8_t,float);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,float,uint8_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint8_t,float);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,float,int16_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int16_t,float);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,float,uint16_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint16_t,float);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,float,int32_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int32_t,float);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,float,uint32_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint32_t,float);
  
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int32_t,int8_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int8_t,int32_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int32_t,uint8_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint8_t,int32_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int32_t,int16_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int16_t,int32_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int32_t,uint16_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint16_t,int32_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int32_t,uint32_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint32_t,int32_t);
  
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint32_t,int8_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int8_t,uint32_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint32_t,uint8_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint8_t,uint32_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint32_t,int16_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int16_t,uint32_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint32_t,uint16_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint16_t,uint32_t);
  
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint16_t,int8_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int8_t,uint16_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint16_t,uint8_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint8_t,uint16_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint16_t,int16_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int16_t,uint16_t);
  
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int16_t,int8_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int8_t,int16_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int16_t,uint8_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint8_t,int16_t);
  
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,uint8_t,int8_t);
  BBTK_ADD_TEMPLATE2_BLACK_BOX_TO_PACKAGE(std,Cast,int8_t,uint8_t);
  
  //====================================================================
  

} // namespace bbstd
