/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbwxInputText.h,v $
  Language:  C++
  Date:      $Date: 2009/12/02 15:13:25 $
  Version:   $Revision: 1.8 $
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         

/**
 * \brief Short description in one line
 * 
 * Long description which 
 * can span multiple lines
 */
/**
 * \file 
 * \brief Pattern for the definition of a new type of Node (header)
 */
/**
 * \class bbtk::NodePatern 
 * \brief Pattern for the definition of a new type of Node 
 */

#ifdef _USE_WXWIDGETS_


#ifndef __bbWxInputText_h__
#define __bbWxInputText_h__

#include "bbtkWxBlackBox.h"

#include "bbwx_EXPORT.h"

namespace bbwx
{

  //=================================================================
  class bbwx_EXPORT InputText : public bbtk::WxBlackBox
  {
    
    BBTK_BLACK_BOX_INTERFACE(InputText,bbtk::WxBlackBox);
    BBTK_DECLARE_INPUT(In,std::string);
    BBTK_DECLARE_INPUT(Title,std::string);
    BBTK_DECLARE_OUTPUT(Out,std::string);
    BBTK_PROCESS(Process);
    void Process();
    BBTK_CREATE_WIDGET(CreateWidget);
    void CreateWidget(wxWindow*);
    
  protected:

  };
  //=================================================================

  //=================================================================
  // BlackBox description
  BBTK_BEGIN_DESCRIBE_BLACK_BOX(InputText,bbtk::WxBlackBox);
  BBTK_NAME("InputText");
  BBTK_AUTHOR("laurent guigues at creatis.insa-lyon.fr");
  BBTK_DESCRIPTION("A zone in which the user can enter a text (wxTextCtrl)");
  BBTK_INPUT(InputText,In,"Initial text (default '')",std::string,"");

  BBTK_INPUT(InputText,Title,"Title of the input zone (default '') ",
	     std::string,"");

  BBTK_OUTPUT(InputText,Out,"Current text",std::string,"");
  BBTK_END_DESCRIBE_BLACK_BOX(InputText);
 
  //=================================================================

}



//namespace bbtk
#endif  //__bbWxInputText_h__

#endif //USE_WXWIDGETS
